; bmp converter
; (c) W. Lenerz 2002

; syntax:
* BMP8CVT  file_in$,file_out$

	section cvt

	xdef	wl_cvt8cp

; some macros

XJSR	macro	name
	xref	[name]		; - makes external jump
	JSR	[name]
	endm

DTRAP	macro	nbr,name
	TRAP	#[nbr]		; trap with error check
	TST.L	D0
	BNE	[name]
	endm

; in QL screen (mode 32)  the colour bits are : gggbbbbb rrrrrggg
; in QL screen (mode 33)  the colour bits are : gggggrrr rrbbbbbw
; where w = intensity. Set to 1 if at least two of the 6th bits in the PC screen)
; for RGB are 1
; in PC 24 colour bitmap, the bits are BGR, and the lines are bottom down!
;


space	EQU	$400
fsize	EQU	2		; total file size
offset	EQU	$a		; offset to bitmap data
hsize	EQU	$E		; header size
width	EQU	$12		; x size of file is here (pixels)
height	EQU	$16		; y size of file is here (pixels)
planes	EQU	$1a		; nbr of planes
type	EQU	$1C		; type of bitmap, must be 24 for 24 bit image
compress	EQU	$1E		; type of compression
size	EQU	$22		; Size of the bitmap data in bytes. This number must be rounded to the next 4 byte boundary
nbcol	EQU	$2e		; nbr of cols used
impcol	EQU	$32		; nbr of important colours (?!)
hlen	EQU	$36		; header length, here starts the data (or palette)


; first get the input filename, open file & load image into mem
wl_cvt8cp
	MOVE.L	#space,D0	; get string from basic, into space
	XJSR	cpy_str 	; pointed then by A0
	BNE	bmp_out 	; oops!
	MOVE.L	A0,A4		; keep pointer to filename space
	MOVEQ	#1,D3		; shared access
	MOVEQ	#1,D0
	MOVEQ	#-1,D1
	DTRAP	2,bmp_out2	; open file
	MOVE.L	A4,A1
	MOVE.L	#$100,D2
	MOVEQ	#$47,D0
	MOVEQ	#-1,D3
	DTRAP	3,bmp_out2	; read file header
	MOVE.L	(A4),D5 	; length of file
	EXG	A0,A4
	XJSR	gu_rchp 	; release mem for filename
	MOVE.L	D5,D0		; length of file
	ADD.L	#space,D0	; + some space for myself
	XJSR	gu_achp 	; get mem for the file
	BNE	bmp_out 	; oops->... (file stays open!!!)
	EXG	A0,A4		; A0 = channel ID, A4 = memptr
	LEA	space(A4),A1	; point to space for file
	MOVE.L	D5,D2
	MOVEQ	#$48,D0 	; greek goddess (scatter load file)
	DTRAP	3,bmp_out3
	MOVEQ	#2,D0
	TRAP	#2		; close input file now

	MOVE.L	A4,A0		; keep mem pointer
	MOVE.L	#$100-10,D0	; max length of output filename
	MOVE.L	$58(A6),A1	; point maths stack
	ADDQ.L	#8,A3
	XJSR	get_str 	; get string now (result filename)
	BNE	bmp_out2		 ; oops!->...

get_size	CLR.L	D1
	CLR.L	D2
	CLR.L	D4		;
	CLR.L	D5		;
	CLR.L	D6		;
	MOVEQ	#-15,D0 	; error bp if wrong file type
	CMP.B	#$8,type+space(A4)	; correct file type?
	BNE	bmp_out 	; no->...
	MOVE.W	width+space(A4),D7	; image X size (nbr pix)in intel format
	BEQ	bmp_out 	; what, 0 sized image???? ->...
	ROL.W	#8,D7		; now in comprehensible format
	SWAP	D7
	MOVE.W	height+space(A4),D7 ; image y size - nbr of lines
	BEQ	bmp_out 	; what, 0 sized image???? ->...
	ROL.W	#8,D7		; now D7 = PC xsize | ysize
	LEA	space-$204(A4),A2	; point to place for my palette
	MOVE.L	D7,(A2)+
; now make my palette map
; A2 points to my map
; A1 points to the PC BMP palette

	MOVE.W	space+nbcol(A4),D3	; nbr of colours for this bitmap
	BNE.S	no_0
	MOVE.W	#255,D3 	; simulate 256 colours palette
	BRA.S	com
no_0	ROL.W	#8,D3
	SUBQ.W	#1,D3
com	LEA	space+hlen(A4),A3	; point to palette
bord32	MOVE.B	(A3)+,D0		; blue
	LSR.B	#3,D0		; get rid of the 3 LSBs
	MOVE.B	(A3)+,D1		; green - upper bits go with red, lower with blue
	ROL.B	#3,D1		; wrap it around
	MOVE.B	D1,D2		; keep
	AND.B	#%11100000,D2	; isolate 3 green bits
	OR.B	D2,D0		; and make GGGBBBBB
	LSL.W	#8,D0		; move into upper byte
	AND.B	#%00000111,D1	; upper 3 bits for green
	MOVE.B	(A3)+,D0
	AND.B	#%11111000,D0
	OR.B	D1,D0
	MOVE.W	D0,(A2)+
	ADDQ.L	#1,A3
	DBF	D3,bord32

	MOVEQ	#1,D0
	MOVEQ	#-1,D1
	MOVEQ	#3,D3		; open overwrite...
	DTRAP	2,bmp_out2
	LEA	space-$204(A4),A1	; point to place for my palette
	MOVE.L	#516,D2
	MOVEQ	#$49,D0
	MOVEQ	#-1,D3		; store the palette
	TRAP	#3		; greek goddess

	MOVE.W	space+offset(A4),D0
	ROL.W	#8,D0
	LEA	space(A4),A1
	ADD.L	D0,A1
	MOVE.L	space+fsize(A4),D2
	ROL.W	#8,D2
	SWAP	D2
	ROL.W	#8,D2		; total file size
	SUB.L	D0,D2		; minus offset to data bytes


	MOVEQ	#$49,D0
	MOVEQ	#-1,D3		; store the data bytes
	TRAP	#3		; greek goddess
bmp_out3	MOVEQ	#2,D0
	TRAP	#2
bmp_out2	MOVE.L	A4,A0		; remease PC screen mem
	XJSR	gu_rchp
	TST.L	D0

bmp_out RTS			; return with(out) error






	end
