	section aurcvt

	xdef	wl_rgb2aur
	xdef	cv_rgb2aur
	xdef	rgb2aur_tab
	xref	rt_int

	include dev8_keys_qlv
	include dev8_keys_sbasic

*********************************************************************
*
*	result%=WL_RGB2AUR(RGB)
*
*	where
*	  result% = Aurora compatible colour byte
*	  RGB = long integer in format	 0 R G B
*
*	converts this long integer into aurora 256 colour byte
*	(as well as possible)
*
*	v. 1.00
*	Copyright (c) W. Lenerz 2003
*	the conversion table is copyright (c) Marcel Kilgus 2002-2003
*	    used with permission (thanks Marcel)
*
*********************************************************************



wl_rgb2aur
	move.w	sb.gtlin,a2
	jsr	(a2)			; get RGB value
	tst.l	d0
	bne.s	bp_err			; ooops!
	addq.l	#4,sb_arthp(a6) 	: reset maths stack pointer
	move.l	(a6,a1.l),d2		; rgb value in d2
	bsr.s	cv_rgb2aur		; convert
	clr.w	d4
	move.b	d2,d4
	bra	rt_int			; and return to basic in D4
bp_err	moveq	#-15,d0
	rts

; convert long RGB0 into aurora palette colour byte
; on entry					exit
; A2 = ?					conversion table
; D2 = 00000000 rrrrrrrr gggggggg bbbbbbbb	? ? ? colour byte
 

cv_rgb2aur
	lsr.b	#5,d2			; 00000000 rrrrrrrr gggggggg 00000bbb
	ror.l	#8,d2			; 00000bbb 00000000 rrrrrrrr gggggggg
	lsr.b	#5,d2			; 00000bbb 00000000 rrrrrrrr 00000ggg
	ror.l	#8,d2			; 00000ggg 00000bbb 00000000 rrrrrrrr
	lsr.b	#5,d2			; 00000ggg 00000bbb 00000000 00000rrr
	swap	d2			; 00000000 00000rrr 00000ggg 00000bbb
	lsl.b	#5,d2			; 00000000 00000rrr 00000ggg bbb00000
	lsl.w	#5,d2			; 00000000 00000rrr gggbbb00 00000000
	lsr.l	#8,d2
	lsr.l	#2,d2			; 00000000 00000000 0000000r rrgggbbb
	lea	rgb2aur_tab(pc),a2
	move.b	(a2,d2.w),d2
	rts

; 3*3 bit RGB to aurora colour
rgb2aur_tab
	dc.b	$00,$00,$04,$05,$20,$21,$24,$25,$02,$02,$06,$07,$22,$23,$26,$27
	dc.b	$10,$10,$14,$15,$30,$31,$34,$35,$12,$12,$16,$17,$32,$33,$36,$37
	dc.b	$80,$80,$84,$85,$A0,$A1,$A4,$A5,$82,$82,$86,$87,$A2,$A3,$A6,$A7
	dc.b	$90,$90,$94,$95,$B0,$B1,$B4,$B5,$92,$92,$96,$97,$B2,$B3,$B6,$B7
	dc.b	$01,$01,$04,$05,$20,$21,$24,$25,$03,$03,$06,$07,$22,$23,$26,$27
	dc.b	$11,$11,$14,$15,$30,$31,$34,$35,$13,$13,$16,$17,$32,$33,$36,$37
	dc.b	$81,$81,$84,$85,$A0,$A1,$A4,$A5,$83,$83,$86,$87,$A2,$A3,$A6,$A7
	dc.b	$91,$91,$94,$95,$B0,$B1,$B4,$B5,$93,$93,$96,$97,$B2,$B3,$B6,$B7
	dc.b	$08,$08,$0C,$05,$28,$21,$2C,$25,$0A,$0A,$0E,$07,$2A,$23,$2E,$27
	dc.b	$18,$18,$1C,$15,$38,$31,$3C,$35,$1A,$1A,$1E,$17,$3A,$33,$3E,$37
	dc.b	$88,$88,$8C,$85,$A8,$A1,$AC,$A5,$8A,$8A,$8E,$87,$AA,$A3,$AE,$A7
	dc.b	$98,$98,$9C,$95,$B8,$B1,$BC,$B5,$9A,$9A,$9E,$97,$BA,$B3,$BE,$B7
	dc.b	$09,$09,$09,$0D,$28,$29,$2C,$2D,$0B,$0B,$0B,$0F,$2A,$2B,$2E,$2F
	dc.b	$19,$19,$19,$1D,$38,$39,$3C,$3D,$1B,$1B,$1B,$1F,$3A,$3B,$3E,$3F
	dc.b	$89,$89,$89,$8D,$A8,$A9,$AC,$AD,$8B,$8B,$8B,$8F,$AA,$AB,$AE,$AF
	dc.b	$99,$99,$99,$9D,$B8,$B9,$BC,$BD,$9B,$9B,$9B,$9F,$BA,$BB,$BE,$BF
	dc.b	$40,$40,$44,$44,$60,$29,$64,$2D,$42,$42,$46,$46,$62,$2B,$66,$2F
	dc.b	$50,$50,$54,$54,$70,$39,$74,$3D,$52,$52,$56,$56,$72,$3B,$76,$3F
	dc.b	$C0,$C0,$C4,$C4,$E0,$A9,$E4,$AD,$C2,$C2,$C6,$C6,$E2,$AB,$E6,$AF
	dc.b	$D0,$D0,$D4,$D4,$F0,$B9,$F4,$BD,$D2,$D2,$D6,$D6,$F2,$BB,$F6,$BF
	dc.b	$41,$41,$41,$45,$45,$61,$64,$65,$43,$43,$43,$47,$47,$63,$66,$67
	dc.b	$51,$51,$51,$55,$55,$71,$74,$75,$53,$53,$53,$57,$57,$73,$76,$77
	dc.b	$C1,$C1,$C1,$C5,$C5,$E1,$E4,$E5,$C3,$C3,$C3,$C7,$C7,$E3,$E6,$E7
	dc.b	$D1,$D1,$D1,$D5,$D5,$F1,$F4,$F5,$D3,$D3,$D3,$D7,$D7,$F3,$F6,$F7
	dc.b	$48,$48,$4C,$4C,$68,$68,$6C,$65,$4A,$4A,$4E,$4E,$6A,$6A,$6E,$67
	dc.b	$58,$58,$5C,$5C,$78,$78,$7C,$75,$5A,$5A,$5E,$5E,$7A,$7A,$7E,$77
	dc.b	$C8,$C8,$CC,$CC,$E8,$E8,$EC,$E5,$CA,$CA,$CE,$CE,$EA,$EA,$EE,$E7
	dc.b	$D8,$D8,$DC,$DC,$F8,$F8,$FC,$F5,$DA,$DA,$DE,$DE,$FA,$FA,$FE,$F7
	dc.b	$49,$49,$49,$4D,$4D,$69,$69,$6D,$4B,$4B,$4B,$4F,$4F,$6B,$6B,$6F
	dc.b	$59,$59,$59,$5D,$5D,$79,$79,$7D,$5B,$5B,$5B,$5F,$5F,$7B,$7B,$7F
	dc.b	$C9,$C9,$C9,$CD,$CD,$E9,$E9,$ED,$CB,$CB,$CB,$CF,$CF,$EB,$EB,$EF
	dc.b	$D9,$D9,$D9,$DD,$DD,$F9,$F9,$FD,$DB,$DB,$DB,$DF,$DF,$FB,$FB,$FF


	END
