	section	get_string

	xdef	get_str
	xdef	cpy_str
	xref	gu_achp

* this does the same as get_str, but gets space for the string first
* on entry:			on exit
* D0 = max length of string		error code on exit
* A0 = ????			pointer to space with string
* error returns same as get_str + get_mem errors

cpy_str	MOVE.W	D0,-(A7)		; keep
	ADDQ.L	#3,D0		; add length word & make even
	BCLR	#0,D0
	JSR	gu_achp		; get mem
	BEQ.S	cpy_ok		; ok ->...
	ADDQ.L	#2,A7		; oops error in get mem
	RTS			; so return
cpy_ok	MOVE.W	(A7)+,D0		; get max string length back
				; now fall through to get_str



* this will get one string into the space pointed to by A0
* on entry:			on exit:
*
* D0 = max length of string		error code
*
* A0 = ptr to space for name		unchanged
* A3 = ptr to param, rel A6		unchanged
*
* all others regs unchaned,
* condition codes set on exit
*
* if successful, this keeps the separator flags in the
* this returns 3 kinds of error:
* -15	genuine error
* -5	the string was longer than maximum permitted
*	(but that maximum was copied)
* -7	the string had 0 length (length word is cleared at (a0))


myregs2	REG	D1-D4/D6/D7/A0/A2/A5
myregs	REG	D1-D7/A0-A5

get_str	MOVEM.L	myregs,-(A7)
	MOVE.W	D0,D5		; keep max length
fname	MOVEQ	#0,D1		; prepare D1
	MOVE.W	(A6,A3.L),D0	; parameter pointer
	ANDI.W	#$F,D0		; eliminate high nibble
	SUBQ.W	#1,D0		; was it a string?
	BEQ.S	is_str		; yes, use vector ->...

no_str	MOVEQ	#0,D2
	MOVEQ	#0,D1
	MOVE.W	2(A6,A3.L),D2	; point to name table
	LSL.L	#3,D2		; * 8 (eight bytes per entry)
	ADD.L	$18(A6),D2	; add offset
	MOVE.W	2(A6,D2.L),A1	; point to value now
	ADDA.L	$20(A6),A1	; add offset: point to string (rel A6)
	MOVE.B	(A6,A1.L),D1	; length of string
	BEQ.S	bp_err		; if 0 length: return error
	ADDQ.L	#1,A1		; adjust pointer
	MOVEQ	#0,D0		; preset	no error
	BRA.S	str_com		; and continue

is_str	LEA	8(A3),A5		; here string is between quotes
	MOVEA.W	$116,A2		; VECTOR to get string param
	MOVE.W	(A6,A3.L),D7
	MOVE.L	A0,-(A7)
	JSR	(A2)		; this corrupts a lot of regs...
	MOVEM.L	(A7)+,A0		; use MOVEM, does not change c codes
	BNE.S	out		; oops
	MOVE.W	D7,(A6,A3.L)
	SUBQ.W	#1,D3		; only one string param
	BNE.S	bp_err
	MOVEQ	#0,D1
	MOVE.W	(A6,A1.L),D1	; length
	BEQ.S	nf		: if 0: complain
	ADDQ.L	#2,A1		; adjust pointer now
* (old: str_com was on next line)
	MOVE.L	D1,D2
	ADDQ.L	#3,D2		; + length word + make even
	BCLR	#0,D2		; make even
	ADD.L	D2,$58(A6)	; reset stack pointer now
str_com	CMP.W	D5,D1		; is string too long for filename?
	BLE.S	cont1		; no, so continue
	MOVEQ	#-5,D0		; error return if string was too long
	MOVE.W	D5,D1		; onlt copy max string
cont1	MOVE.W	D1,(A0)+		; length of string
	SUBQ.W	#1,D1		; prepare for dbf
strlop1	MOVE.B	(A6,A1.L),(A0)+	; put string into my space
	ADDQ.L	#1,A1
strgt3	DBF	D1,strlop1
out	MOVEM.L	(A7)+,myregs
	TST.L	D0
	RTS
bp_err	MOVEQ	#-15,D0
	BRA.S	out

nf	CLR.W	(A0)		; no length in string
	MOVEQ	#-7,D0		; error return if 0 length string
	BRA.S	out
; GET_STR2
; THIS GETS THE LENGTH OF A STRING FROM THE BASIC INTERPRETER

; entry				exit
; D0				0  or length
; A1 top of math stack		A1 pointer to string, after length word
;				   rel to A6
; A3 pointer to start of parameter	A3 preserved
;
; all other registers presered, condition codes set on exit
; Attention, D0 returns 0 if error!
; if this was a string, this routine does NOT reset the maths stack
; if successful, this keeps the seprarator flag in the type word

	section	get_str2

	XDEF	get_str2

get_str2	MOVEM.L	myregs2,-(A7)
	MOVEQ	#0,D0
	MOVE.B	1(A6,A3.L),D0
	ANDI.B	#$F,D0
	SUBQ.B	#1,D0		; was it a string?
	BEQ.S	is_str2		; yes
	MOVEQ	#0,D2
	MOVE.W	2(A6,A3.L),D2	; point to name table
	LSL.L	#3,D2		; * 8 (eight bytes per entry)
	ADD.L	$18(A6),D2	; add offset
	MOVE.W	2(A6,D2.L),A1	; point to value now
	ADDA.L	$20(A6),A1	; add offset
	MOVE.B	(A6,A1.L),D0	; length of string
	BEQ.S	bp_err		; if 0 length: return
	ADDQ.L	#1,A1		; adjust pointer
	BRA.S	ok		; and continue

is_str2	MOVE.L	A3,A5
	ADDQ.L	#8,A5
	MOVEA.W	$116,A2
	MOVE.W	(A6,A3.L),D7
	JSR	(A2)		; get string
	BNE.S	err
	MOVE.W	D7,(A6,A3.L)
	SUBQ.W	#1,D3		; only one string param
	BNE.S	err
	MOVE.W	(A6,A1.L),D0	; length
	BEQ.S	ok
	ADDQ.L	#2,A1		; adjust pointer
	BRA.S	ok
err	MOVEQ	#0,D0
ok	MOVEM.L	(A7)+,myregs2
	TST.W	D0
	RTS

	END
