*********************************************************************
*
*  jobID = WL_FADE [#chan%,] x%,y%,step%, start_colour, end_colour, string$
*
* this sets up a new job the purpose of which is to fade to the end colour
* the string in the channel
*
* it is a function that returns the job ID of that job
* ******************************************************************


	section fade

	xdef	fade
	xdef	fade_end

	xref	chan_num2
	xref	rt_fp
fade_bp MOVEQ	#-15,D0
f_out	RTS
fade	BSR	chan_num2	; get channel ID into A4
	BNE.S	f_out		; oops
	SUBQ.L	#8,A5
	MOVE.W	$118,A2
	JSR	(A2)		; get long ints
	TST.L	D0
	BNE.S	f_out		; oops->...
	SUBQ.L	#5,D3		; there must be five
	BNE.S	fade_bp
	ADD.L	#20,$58(A6)	; reset maths stack
	MOVE.L	$2(A6,A1.L),D7	; x%
	MOVE.W	6(A6,A1.L),D7	; x% | y%
	MOVE.L	8(A6,A1.L),D4	; step%
	MOVE.L	12(a6,a1.l),D5	; start col
	MOVE.L	16(A6,A1.L),D6	; end col
	MOVE.L	A5,A3
	ADDQ.L	#8,A5		; point to last param
	MOVEM.L D4/D6,-(A7)
	MOVE.W	$116,A2
	JSR	(A2)
	MOVEM.L (A7)+,D4/D6
	TST.L	D0
	BNE.S	f_out
	MOVE.L	A1,A2
	ADD.L	A6,A2		; point to string now

; MOVE.L	  A5,A3
; MOVE.B	  $BD(A6),D3	  ; colour mode byte!
; BRA.S TRUEJOB

setprm	MOVEQ	#$14,D2
	MOVEQ	#$64,D3 	; data & code space
	ADD.W	(A6,A1.L),D3	; make space for the length of the string
	ADDQ.W	#3,D3
	BCLR	#0,D3
	LEA	truejob,A3
	MOVEQ	#-1,D1		; owner is myself
	SUBA.L	A1,A1
	MOVEQ	#1,D0
	TRAP	#1		; create job
	TST.L	D0
	BNE.S	f_out		; ooops
	LEA	-$14(A0),A5
	MOVE.W	#$4EF9,(A0)+
	MOVE.L	A3,(A0)+	; put in jump to job
	MOVE.W	#$4AFB,(A0)+
	MOVE.W	#$4,(A0)+
	MOVE.L	#'Fade',(A0)+
	MOVE.L	A0,A3
	MOVE.W	(A2)+,D0	; length of string to print
	MOVE.W	D0,(A0)+
	ADDQ.W	#1,D0
	LSR.W	#1,D0
	BRA.S	do_cpy
cpy_lp1 MOVE.W	(A2)+,(A0)+
do_cpy	DBF	D0,cpy_lp1	; copy string across
	MOVE.B	$BD(A6),D3	; colour mode byte!
	MOVEM.L D2-D7/A0-A4,-(A5); give the new job my registers now (!)

	MOVEQ	#0,D3		; this job continues to execute
	MOVE.L	D1,D4		; keep job ID
	MOVEQ	#1,D2		; priority 1
	MOVEQ	#$A,D0
	TRAP	#$1		; activate job
	MOVE.L	D4,D2
	BRA	rt_fp

; this is the job now
; A3 = string to print
; A4 = channel ID
; D3 = colour mode byte
; D4 = step%
; d5 = start col
; D6 = end col
; D7 = x%, y%
truejob SWAP	D4
	MOVE.L	A4,A0		; channel ID
	SUB.L	#12,A7
	MOVE.L	A7,A2		; point to space for colour
	MOVE.L	#-1,8(A2)	; no stipple
	TST.B	D3
	BNE.S	no_ql
	MOVE.W	#$29,D4 	; INK trap call if ql mode
	BRA.S	col_all
no_ql	SUB.W	#$50,D3 	; is it PAL?
	BNE.S	no_pal		; no
	MOVE.W	#$52,D4 	; trap call if pal mode
	BRA.S	col_all
no_pal	SUBQ.W	#4,D3		; is it 24 colour?
	BNE.S	no_24		; no->...
	MOVE.W	#$56,D4 	; trap call if 24bit mode
	LSL.L	#8,D5
	LSL.L	#8,D6
	BRA.S	col_all
no_24	MOVEQ	#$5A,D7 	; block drawing trap call if native mode
col_all MOVEQ	#-1,D3
loop	MOVE.W	D7,D2
	SWAP	D7
	MOVE.W	D7,D1
	SWAP	D7
	MOVEQ	#$17,D0
	TRAP	#3		; set to cursor pixel position
	TST.L	D0
	BNE.S	harakiri
	MOVEQ	#3,D2
	SWAP	D4		 ; trap code | step%
lp1	CLR.W	D0
	MOVE.B	D5,D0
	SUB.W	D4,D0		; minus step now
	BMI.S	end_red1		; oops
	CMP.B	D0,D6
	BGE.S	end_red
end_red1	MOVE.B	D6,D0
end_red MOVE.B	D0,D1
	LSL.L	#8,D1		; ready for next byte
	ROL.L	#8,D5
	ROL.L	#8,D6
	DBF	D2,lp1
	MOVE.L	D1,(A2)
	MOVE.L	D1,4(A2)
	MOVE.L	D1,D5
	CLR.L	D0
	SWAP	D4		; set ink now
	MOVE.W	D4,D0
	TRAP	#3		; greek goddess
	TST.L	D0
	BNE.S	harakiri
	MOVE.L	A3,A1
	MOVE.W	(A1)+,D2
	MOVEQ	#7,D0
	TRAP	#3		; greek goddess (multiple bytes)
	TST.L	D0
	BNE.S	harakiri
	CMP.L	D5,D6
	BEQ.S	harakiri
	MOVEQ	#-1,D1
	MOVEQ	#2,D3
	SUB.L	A1,A1
	MOVEQ	#8,D0
	MOVE.L	A0,-(A7)
	TRAP	#1
	MOVE.L	(A7)+,A0
	BRA.S	col_all
harakiri
	ADD.L	#12,A7
	MOVEQ	#-1,D1
h2	MOVEQ	#5,D0
	MOVEQ	#0,D3
	TRAP	#1
	MOVEQ	#0,D0		; no eror, whatever happens
fout	RTS

************
* FADE_END jobID
* stop a fadejob w/o error (even if job doesn't exist anymore)
****************
fade_end
	MOVE.W	$118,A2
	JSR	(A2)		; get long ints
	TST.L	D0
	BNE.S	fout		; oops->...
	EXT.L	D3
	LSL.W	#2,D3
	ADD.L	D3,$58(A6)
	MOVE.L	(A6,A1.L),D1
	BRA.S	h2

	END
