	section panl

**************************************************************
* NPAN [#chan%],step%,xorig%,xsize%,yorig%,ysize%,direction%,memory
* where
*	step% = nbr of pixels to pan
*	xorig% = pixel to start at (from 0 to end of screen/line)
*	xsize% = nbr pixels to pan
*	yorig%,ysize%: same for lines
*	direction% = roll/pan in what direction?
*		0 = left
*		1 = right
*		2 = up
*		3 = down
*	MEMORY =	mem parameter for PE window save area
*
*
* (c) W. Lenerz 2002
*
* v. 1.00 2002 Feb 24 11:51:40
******************************************************

	xdef	npan
	XREF	chan_num
	XREF	scr_xsize
	xref	scr_ysize
mynum	EQU	8

npan	BSR	chan_num		; get channel ID into A0, default =#1
	BNE.S	panl_out		; ooops! ->...
	MOVE.W	$118,A2
	JSR	(A2)		; get integers
	TST.L	D0		; OK?
	BNE.S	panl_out		; nO! ->...
	SUBQ.W	#7,D3		; are there exactly 7 ints?
	BNE.S	err_bp		; no! ->...
	MOVE.L	(A6,A1.L),D5	; step%
	MOVE.L	6(A6,A1.L),D6	; xorig%
	MOVE.W	10(A6,A1.L),D6	; xorig% | xsize%
	MOVE.L	14(A6,A1.L),D7	;
	MOVE.W	18(A6,A1.L),D7	; yorig% | ysize%
	MOVE.L	24(A6,A1.L),A2	; memptr
	SUBQ.L	#4,A2
	ADD.L	#28,$58(A6)	; reset the maths stack
	MOVEQ	#1,D2		; always keep block
	MOVE.L	20(A6,A1.L),D3	; direction flag
	BNE.S	no_left		; it isn't left->...
; now make the params for the calls
; A :
; D1   =	xorig%+step%, yorig%
; (A1) =	xsize%-step%, ysize%
;	xorig%,	    yorig%

left	MOVEQ	#-1,D3		; timeout
	SUB.L	#mynum,A7
	MOVE.L	A7,A1
	MOVE.W	D5,D1		; step%
	CLR.L	D4
	MOVE.W	D6,D4		; xsize%
	SUB.W	D1,D4		; Xsize%-step%
	SWAP	D6		; xsize% | xorig%
	ADD.W	D6,D1		; xorig%+ step%
	SWAP	D1
	MOVE.W	D7,2(A1)		; ysize%
	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D1		; xorig%+step% | yorig%
	MOVE.W	D4,(A1)		; xsize%-step%
	MOVE.W	D6,4(A1)		; xorig%
	MOVE.W	D7,6(A1)		; yorig
	MOVEQ	#$6E,D0
	TRAP	#3
	TST.L	D0
	BNE.S	panlout2
; B :
; D1   =	xorig%,	yorig%
; (A1) =	step%,	ysize%
;	xorig%+xsize%-step%,yorig%
; here 2(a1) & 6 (a1) stay as they are
	MOVE.L	A7,A1
	MOVE.L	4(A1),D1		; xorig% | yorig%
	MOVE.W	D5,(A1)		; step%
	ADD.W	D4,4(A1)		; xorig%+xsize%-step%
	MOVEQ	#$6E,D0
	TRAP	#3
panlout2	ADD.L	#mynum,A7
	TST.L	D0
panl_out	RTS

err_bp	MOVEQ	#-15,D0
	RTS


no_left	SUBQ.W	#1,D3
	BNE.S	no_right

; here, we're moving right
; now make the params for the calls
; A :
; D1   =	xorig%,	    yorig%
; (A1) =	xsize%-step%, ysize%
;	xorig%+step%, yorig%
; on entry:
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%

right	MOVEQ	#-1,D3		; timeout
	SUB.L	#mynum,A7
	MOVE.L	A7,A1		; get some space for myself

	MOVE.W	D7,2(A1)		; ysize%
	MOVE.W	D6,D4		; xsize%
	SUB.W	D5,D4		, xsize%-step%
	MOVE.W	D4,(A1)		; xsize%-step%
	SWAP	D6		; xsize% | xorig%
	SWAP	D7		; ysize% | yorig%
	MOVE.W	D6,D1		; xorig%
	SWAP	D1
	MOVE.W	D7,D1		; xorig% | yorig%
	MOVE.W	D5,4(A1)		; step%
	ADD.W	D6,4(A1)		; step% + xorig%
	MOVE.W	D7,6(A1)		; yorig%
	MOVEQ	#$6E,D0
	TRAP	#3
	TST.L	D0
	BNE.S	panlout3
; B :
; D1   =	xorig%+xsize%-step%,yorig%
; (A1) =	step%,		ysize%
;	xorig%,		yorig%
; here, 2(a1) & 6(a1) don't change
	MOVE.L	A7,A1
	MOVE.L	D1,4(A1)		; xorig% | yorig%
	SWAP	D1		; yorig% | xorig%
	ADD.W	D4,D1		; yorig% | xorig%+xsize%-step%
	SWAP	D1		; xorig%+xsize%-step% | yorig%
	MOVE.W	D5,(A1)		; step%
	MOVEQ	#$6E,D0
	TRAP	#3
panlout3	ADD.L	#mynum,A7
	TST.L	D0
	RTS

no_right	SUBQ.W	#1,D3
	BNE.S	no_up


; here: UP
; now make the params for the calls
; A :
; D1   =	xorig%, yorig%+step%
; (A1) =	xsize%, ysize%-step%
;	xorig%, yorig%
; on entry:
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%

up	MOVEQ	#-1,D3		; timeout
	SUB.L	#mynum,A7
	MOVE.L	A7,A1
	MOVE.W	D7,D4		; ysize%
	SUB.W	D5,D4		; ysize% - step%
	MOVE.W	D4,2(A1)		; ysize% - step%
	MOVE.W	D6,(A1)		; xsize%
	MOVE.L	D6,D1		; xorig% | xsize%
	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D1		; xorig% | yorig%
	MOVE.L	D1,4(A1)		; xorig%, yorig%
	ADD.W	D5,D1		; xorig% | yorig%+ step%
	MOVEQ	#$6E,D0
	TRAP	#3
	TST.L	D0
	BNE.S	up_out
; B :
; D1   =	xorig%, yorig%
; (A1) =	xsize%, step%
;	xorig%, yorig%+ysize%-step%
; here: 0(a1) & 4(a1) stay as they are
	MOVE.L	A7,A1
	SUB.W	D5,D1		; xorig% | yorig%
	MOVE.W	D5,2(A1)		; step%
	ADD.W	D4,6(A1)		; yorig% + ys%-step%
	MOVEQ	#$6E,D0
	TRAP	#3
up_out	ADD.L	#mynum,A7
	TST.L	D0
	RTS

no_up	SUBQ.W	#1,D3
	BNE.S	no_down
; here: down
; now make the params for the calls
; A :
; D1   =	xorig%, yorig%
; (A1) =	xsize%, ysize%-step%
;	xorig%, yorig%+step%
; on entry:
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%

down	MOVEQ	#-1,D3		; timeout
	SUB.L	#mynum,A7
	MOVE.L	A7,A1
	MOVE.W	D7,D4
	SUB.W	D5,D4		; ysize% - step%
	MOVE.W	D4,2(A1)
	MOVE.W	D6,(A1)		; xsize%
	MOVE.L	D6,D1		; xorig% | xsize%
	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D1		; xorig% | yorig%
	MOVE.L	D1,4(A1)		; xorig% | yorig%
	ADD.W	D5,6(A1)		; xorig% | yorig% + STEP%

	MOVEQ	#$6E,D0
	TRAP	#3
	TST.L	D0
	BNE.S	up_out
; B :
; D1   =	xorig%, yorig%+ysize%-step%
; (A1) =	xsize%, step%
;	xorig%, yorig%
; here 0(a1) & 4(a1) stays the same

	MOVE.L	A7,A1
	MOVE.W	D1,6(A1)		; yorig%
	ADD.W	D4,D1		; yorig%+ysize%-step%
	MOVE.W	D5,2(A1)
	MOVEQ	#$6E,D0
	TRAP	#3
	TST.L	D0
	ADD.L	#mynum,A7
	TST.L	D0
	RTS

no_down	MOVEQ	#-19,D0
	RTS
	end
