	section panl

**************************************************************
* NPAN [#chan%],xstep%,ystep%,xorig%,xsize%,yorig%,ysize%,direction%,memory
* where
*	step% = nbr of pixels to pan
*	xorig% = pixel to start at (from 0 to end of screen/line)
*	xsize% = nbr pixels to pan
*	yorig%,ysize%: same for lines
*	direction% = roll/pan in what direction?
*		0 = left
*		1 = right
*		2 = up
*		3 = down
*	MEMORY =	mem parameter for PE window save area
*
*
* (c) W. Lenerz 2002
*
* v. 1.00 2002 Feb 24 11:51:40
******************************************************

	xdef	npand
	XREF	chan_num
	XREF	scr_xsize
	xref	scr_ysize
mynum	EQU	8


err_bp	MOVEQ	#-15,D0
panlout	RTS
npand	BSR	chan_num		; get channel ID into A0, default =#1
	BNE.S	panlout		; ooops! ->...
	MOVE.W	$118,A2
	JSR	(A2)		; get integers
	TST.L	D0		; OK?
	BNE.S	panlout		; nO! ->...
	SUBQ.W	#8,D3		; are there exactly 7 ints?
	BNE.S	err_bp		; no! ->...
	MOVE.L	2(A6,A1.L),D5	; xstep%
	MOVE.W	6(A6,A1.L),D5	; ystep%
	MOVE.L	10(A6,A1.L),D6	 ; xorig%
	MOVE.W	14(A6,A1.L),D6	; xorig% | xsize%
	MOVE.L	18(A6,A1.L),D7	;
	MOVE.W	22(A6,A1.L),D7	; yorig% | ysize%
	MOVE.L	28(A6,A1.L),A2	; memptr
	SUBQ.L	#4,A2
	ADD.L	#32,$58(A6)	; reset the maths stack
	MOVEQ	#1,D2		; always keep block
	MOVE.L	24(A6,A1.L),D3	; direction flag
	SUBQ.W	#4,D3
	BNE	no_left		; it isn't left->...

; here we're panning up left
; now make the params for the calls
; A :
; D1   =	xorig%+xstep%, yorig%+ystep%
; (A1) =	xsize%-xstep%, ysize%-ystep%,
;	xorig%,	     yorig%
; ON ENTRY
; D5 = xstep% | ystep%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%
upleft	MOVEQ	#-1,D3		; timeout
	SUB.L	#mynum,A7
	MOVE.L	A7,A1

	MOVE.W	D7,D4
	SUB.W	D5,D4
	SWAP	D4		; ysize% - ystep% | ???

	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,6(A1)				* 6
	MOVE.W	D7,D1
	ADD.W	D5,D1		; yorig%+ystep%
	MOVE.W	D6,D4		; xsize%
	SWAP	D6		; xsize%	| xorig%
	MOVE.W	D6,4(A1)		; xorig%		* 4
	SWAP	D1
	MOVE.W	D6,D1		; xorig%
	SWAP	D5		; ystep% | xstep%
	ADD.W	D5,D1		; xorig%+xstep%
	SWAP	D1		; correct params now* D1
	SUB.W	D5,D4		; xsize%-xstep%
	SWAP	D4		; xsize%-xstep%  | ysize%-ystep%
	MOVE.L	D4,(A1)		;		* 0, 2
	MOVEQ	#$6E,D0
	TRAP	#3
	TST.L	D0
	BNE.S	panlout2
; B :
; D1   =	xorig%+xstep%, yorig%
; (A1) =	xsize%-xstep%, ystep%,
;	xorig%,	     yorig%+ysize%-ystep%
; D5 TO D7 ARE SWAPPED!
; here (a1) & 4 (a1) stay as they are			* 0,4
	MOVE.L	A7,A1
	SWAP	D5		; xstep% | ystep%
	MOVE.W	2(A1),D0		; ysize%-ystep%
	MOVE.W	D5,2(A1)		; ystep%		* 2
	SUB.W	D5,D1		;		* D1
	ADD.W	D7,D0		; yorig%+ysize%-ystep%
	MOVE.W	D0,6(A1)		;		* 6
	MOVEQ	#$6E,D0
	TRAP	#3
; C :
; D1   =	xorig%,yorig%
; (A1) =	xstep%,ystep%,
;	xorig%+xsize%-xstep%,yorig%+ysize%-ystep%
; ON ENTRY
; D4 = xsize%-xstep%  | ysize%-ystep%
; D5 = xstep% | ystep%
; D6 = xsize% | xorig%		***
; D7 = ysize% | yorig%		***

; here 6 (a1) stay as they are			* 6
	MOVE.W	D7,D1
	SWAP	D1		; xorig% | yorig%	* D1
	MOVE.W	D6,D1		; yorig% | xorig%
	MOVE.L	D5,(A1)		; xstep%,ystep%	* 0,2
	SWAP	D4		; yorig% | ysize%
	MOVE.W	D4,D0		; xsize%-xstep%
	ADD.W	D6,D0		; xorig%+xsize%-xstep%
	MOVE.W	D4,4(A1)		;		* 4
	MOVEQ	#$6E,D0
	TRAP	#3
; D :
; D1   =	xorig%,yorig%+ystep%,
; (A1) =	xstep%,ysize%-ystep%,
;	xorig%+xsize%-xstep%,yorig%
; ON ENTRY
; D4 = ysize%-ystep% | xsize%-xstep%
; D5 = xstep% | ystep%
; D6 = xsize% | xorig%		***
; D7 = ysize% | yorig%		***

; here 4 (a1) stay as they are			* 4
	MOVE.W	D1,6(A1)		; yorig%		* 6
	ADD.W	D5,D1		; xorig% | yorig%+ystep% * D1
	SWAP	D5
	MOVE.W	D5,(A1)		; xstep%		* 0
	SWAP	D4
	MOVE.W	D4,2(A1)		; ysize%-ystep%	* 2
	MOVEQ	#$6E,D0
	TRAP	#3
panlout2	ADD.L	#mynum,A7
	TST.L	D0
panl_out	RTS

no_left	SUBQ.W	#1,D3
	BNE.S	no_right

; here, we're moving up right
; now make the params for the calls
; A :
; D1   =	xorig%,yorig%+ystep%,
; (A1) =	xsize%-xstep%,ysize%-ystep%,
;	xorig%+xstep%,yorig%

; ON ENTRY
; D5 = xstep% | ystep%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%
upright	MOVEQ	#-1,D3		; timeout
	SUB.L	#mynum,A7
	MOVE.L	A7,A1		; get some space for myself

	MOVE.W	D7,D4
	SUB.W	D5,D4
	SWAP	D4		; ysize% - ystep% | ???

	MOVE.W	D5,D0		; ystep%
	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,6(A1)		; yorig%		* 6
	MOVE.L	D6,D1		; xorig% | xsize%
	ADD.W	D7,D0		; ystep%+yorig%
	MOVE.W	D0,D1		; xorig% | ystep%+yorig% * D1
	MOVE.W	D6,D4		; xsize%
	SWAP	D5		; ystep% | xstep%
	SUB.W	D5,D4		; xsize%-xstep%
	SWAP	D4		; xsize%-xstep% | ysize% - ystep%
	MOVE.L	D4,(A1)		;		* 0, 2
	SWAP	D6		; xsize% | xorig%
	MOVE.W	D6,D0		; xorig%
	ADD.W	D5,D0		; xorig% + xstep%
	MOVE.W	D0,4(A1)		;		* 4
	MOVEQ	#$6E,D0
	TRAP	#3

; now make the params for the calls
; B :
; D1   =	xorig%,yorig%,
; (A1) =	xsize%-xstep%,ystep%,
;	xorig%+xstep%,yorig%+ysize%-ystep%
; D5 - D7 SWAPPED
; 0 & 4 (A1) stet					* 0,4
	MOVE.W	D7,D1		; xorig% | yorig%	* D1
	ADD.W	D4,6(A1)		; yorig%+ysize%-ystep% * 6
	SWAP	D5		; xstep% | ystep%
	MOVE.W	D5,2(A1)		;		* 2
	MOVEQ	#$6E,D0
	TRAP	#3
; now make the params for the calls
; C :
; D1   =	xorig%+xsize%-xstep%,yorig%,
; (A1) =	xstep%,ystep%,
;	xorig%,yorig%+ysize%-ystep%

; D4 = xsize%-xstep% | ysize%-ystep%
; D5 = xstep% | ystep%
; D6 = xsize% | xorig%		***
; D7 = ysize% | yorig%		***
; 2 & 6(A1) stet					* 2,6
	MOVE.W	D6,D1		; xorig%
	SWAP	D4		; ysize%-ystep% | xsize%-xstep%
	ADD.W	D4,D1		; xorig%+xsize%-xstep%
	SWAP	D1
	MOVE.W	D7,D1		; xorig%+xsize%-xstep% | yorig% * D1
	MOVE.L	D5,(A1)		;		* 0,2
	MOVE.W	D6,4(A1)		; xorig%		* 4
	MOVEQ	#$6E,D0
	TRAP	#3
; now make the params for the calls
; D :
; D1   =	xorig%+xsize%-xstep%,yorig%+ystep%,
; (A1) =	xstep%,ysize%-ystep%,
;	xorig%,yorig%
; 0 & 4(a1) stet					* 0,4
	ADD.W	D5,D1		; yorig%+step%	* D1
	SWAP	D4
	MOVE.W	D4,2(A1)		; ysize%-ystep%
	MOVE.W	D7,6(A1)		; yorig%
	MOVEQ	#$6E,D0
	TRAP	#3
	ADD.L	#mynum,A7
	TST.L	D0
	RTS




no_right	SUBQ.W	#1,D3
	BNE.S	no_up


; downleft
; now make the params for the calls
; A :
; D1   =	xorig%+xstep%,yorig%,
; (A1) =	xsize%-xstep%,ysize%-ystep%,
;	xorig%,yorig%+ystep%

; ON ENTRY
; D5 = xstep% | ystep%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%
downleft	MOVEQ	#-1,D3		; timeout
	SUB.L	#mynum,A7
	MOVE.L	A7,A1		; get some space for myself

	MOVE.W	D7,D4
	SUB.W	D5,D4
	MOVE.W	D4,2(A1)		;		* 2
	SWAP	D4		; ysize% - ystep% | ???

	MOVE.W	D5,D0		; ystep%
	SWAP	D7		; ysize% | yorig%
	ADD.W	D7,D0		; yorig%+ystep%
	MOVE.W	D0,6(A1)		; yorig%		* 6

	MOVE.W	D6,D4		; xsize%
	SWAP	D6		; xsize% | xorig%
	MOVE.W	D6,4(A1)		; xorig%		* 4
	SWAP	D5
	SUB.W	D5,D4		; xsize%-xstep%
	MOVE.W	D4,(A1)		;		* 0
	MOVE.W	D6,D1		; xorig%
	ADD.W	D5,D1		; + xstep%
	SWAP	D1
	MOVE.W	D7,D1		; yorig%		* D1
	MOVEQ	#$6E,D0
	TRAP	#3
     
; now make the params for the calls
; B :
; D1   =	xorig%,yorig%+ysize%-ystep%,
; (A1) =	xsize%-xstep%,ystep%,
;	xorig%,yorig%
; D4 = ysize%- ystep% | xsize%-xstep%
; D5 - D7 SWAPPED
; 0 & 4 (a1) stet					* 0,4
	MOVE.W	D7,6(A1)		; yorig%		* 6
	MOVE.W	D7,D1		; yorig%
	SWAP	D4
	ADD.W	D4,D1		; yorig%+ysize%-ystep%  * D1
	SWAP	D5		; xstep% | ystep%
	MOVE.W	D5,2(A1)		; ystep%		* 2

	MOVEQ	#$6E,D0
	TRAP	#3

; now make the params for the calls
; C :
; D1   =	xorig%,yorig%+ysize%-ystep%,
; (A1) =	xstep%,ystep%,
;	xorig%+xsize%-xstep%,yorig%
; D1 stet
; ON ENTRY
; D4 = xsize%-xstep%  | ysize%-ystep%
; D5 = xstep% | ystep%
; D6 = xsize% | xorig%		***
; D7 = ysize% | yorig%		***
; D1 stet 					* D1
	MOVE.L	D5,(A1)		;		* 0,2
	MOVE.W	D7,6(A1)		;		* 6
	SWAP	D4
	ADD.W	D4,4(A1)				* 4
	MOVEQ	#$6E,D0
	TRAP	#3

; now make the params for the calls
; D :
; D1   =	xorig%,yorig%,
; (A1) =	xstep%,ysize%-ystep%,
;	xorig%+xsize%-xstep%,yorig%+ystep%
; D4 SWAPPED
; 0,4(a1) stet					* 0,4
	MOVE.W	D7,D1		; yorig%		* D1
	SWAP	D4		;
	MOVE.W	D4,2(A1)		; ysize%-ystep%	* 2
	ADD.W	D5,D7		; yorig%+ystep%
	MOVE.W	D7,6(A1)				* 6
	MOVEQ	#$6E,D0
	TRAP	#3
	ADD.L	#mynum,A7
	TST.L	D0
	RTS


no_up	SUBQ.W	#1,D3
	BNE.S	no_down

; DOWNRIGHT

; now make the params for the calls
; A :
; D1   =	xorig%,yorig%,
; (A1) =	xsize%-xstep%,ysize%-ystep%,
;	xorig%+xstep%,yorig%+ystep%
; ON ENTRY
; D5 = xstep% | ystep%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%
downright MOVEQ	#-1,D3		; timeout
	SUB.L	#mynum,A7
	MOVE.L	A7,A1		; get some space for myself

	MOVE.W	D7,D0
	SUB.W	D5,D0		; ysize% - ystep%

	SWAP	D5		; ystep%,xstep%
	MOVE.W	D6,D4		; xsize%
	SUB.W	D5,D4		; -xstep%
	SWAP	D4
	MOVE.W	D0,D4
	MOVE.L	D4,(A1)		; xsize%-xstep%,ysize%-ystep% * 0,2
	MOVE.L	D6,D1		; xorig% | ???
	SWAP	D6
	SWAP	D7
	MOVE.W	D7,D1		; xorig% | yorig%	* D1
	MOVE.W	D6,D0		; xorig%
	ADD.W	D5,D0		; ...+ xstep%
	SWAP	D0
	SWAP	D5
	MOVE.W	D5,D0
	ADD.W	D7,D0
	MOVE.L	D0,4(A1)		;		* 4,6
	MOVEQ	#$6E,D0
	TRAP	#3
		

; now make the params for the calls
; B :
; D1   =	xorig%,yorig%+ysize%-ystep%,
; (A1) =	xsize%-xstep%,ystep%,
;	xorig%+xstep%,yorig%
; D4 = xsize%-xstep% | ysize%-ystep%
; D6 - D7 swapped
; 0 & 4(a1) stet					0 0,4
	MOVE.W	D1,6(A1)		; yorig%		* 6
	ADD.W	D4,D1		; yorig%+ysize%-ystep% * D1
	MOVE.W	D5,2(A1)		; ystep%		* 2
	MOVEQ	#$6E,D0
	TRAP	#3

; now make the params for the calls
; C :
; D1   =	xorig%+xsize%-xstep%,yorig%+ysize%-ystep%,
; (A1) =	xstep%,ystep%,
;	xorig%,yorig%

; D4 = xsize%-xstep% | ysize%-ystep%
; D5 = xstep% | ystep%
; D6 = xsize% | xorig%		***
; D7 = ysize% | yorig%		***
; 2 & 6 (A1) STET					* 2,6
	SWAP	D1		; yorig%+ysize%-ystep%| xorig%
	MOVE.W	D1,4(A1)				* 4
	SWAP	D4
	ADD.W	D4,D1
	SWAP	D1				* D1
	SWAP	D5
	MOVE.W	D5,(A1)				* 0
	MOVEQ	#$6E,D0
	TRAP	#3

; now make the params for the calls
; D :
; D1   =	xorig%+xsize%-xstep%,yorig%,
; (A1) =	xstep%,ysize%-ystep%,
;	xorig%,yorig%+ystep%
; D4 = ysize%-ystep% | xsize%-xstep%
; 0 & 4(A1) STET					* 0,4
	MOVE.W	D7,D1				* D1
	SWAP	D5
	ADD.W	D5,D7		; yorig% +ystep%
	MOVE.W	D7,6(A1)				* 6
	SWAP	D4
	MOVE.W	D4,2(A1)				* 2
	MOVEQ	#$6E,D0
	TRAP	#3
	ADD.L	#mynum,A7
	TST.L	D0
	RTS

no_down	MOVEQ	#-19,D0
	RTS
	end
